// Class number 1

function B1(n1,k1,l1)
    return Group<a,l,t,u|a^2,l^2,(t*l)^2,(u*l)^2,(a*l)^2,
                         (t*a)^3,(u*a*l)^3,(t,u),
    
                         t^n1,t^k1*u^l1>;
end function;

function B2(n,k,l)
    return Group<a,t,u|a^2,(t*a)^3,(a*u^-1*a*u)^2,(t,u),

                       t^n,t^k*u^l>;
end function;

function B3(n1,k1,l1)
    return Group<a,l,t,u|(t,u),a^2,(a*l)^2,(t*a)^3,l^3,(u*a*l)^3,
                         l^-1*t*l*u*t,l^-1*u*l*t^-1,
                         
                         t^n1,t^k1*u^l1>;
end function;

function B7(n,k,l)
    return Group<a,t,u|a^2,(t*a)^3,(a*t*u^-1*a*u)^2,(t,u),

                       t^n,t^k*u^l>;
end function;

function B11(n,k,l)
    return Group<a,t,u|a^2,(t*a)^3,(a*t*u^-1*a*u)^3,(t,u),

                       t^n,t^k*u^l>;
end function;

function B19(n,k,l)
    return Group<a,b,t,u|a^2,(t*a)^3,b^3,(b*t^-1)^3,(a*b)^2,
                         (a*t^-1*u*b*u^-1)^2,(t,u),

                         t^n,t^k*u^l>;
end function;

// Higher class numbers

function B5(n,k,l)
    return Group<a,b,c,t,u | (t,u), a^2, b^2, (t*a)^3, (a*b)^2,
                             (a*u*b*u^-1)^2, a*c*a*t*c^-1*t^-1,
                             u*b*u^-1*c*b*t*c^-1*t^-1,

                             t^n, t^k*u^l,
                             (t*b)^n,(t*b)^k*(t*u^-1*c*t^-1)^l>;
end function;

function B6(n,k,l)
    return Group<a,t,u,b,c|a^2,b^2,(t,u),(t*a)^3,(a,c),
                           t^-1*c*t*u*b*u^-1*c^-1*b^-1,
                           (a*t*b)^3,(a*t*u*b*u^-1)^3,

                           t^n,t^k*u^l,
                           (t*b)^n,(t*b)^k*(c*u)^-l>;
end function;

function B15(n1,k1,l1,  n2,k2,l2)
    return Group<a,t,u,c|
        (t,u),(a,c),a^2,(t*a)^3,u*c*u*a*t*u^-1*c^-1*u^-1*a*t^-1,

        t^n1, t^k1*u^l1,
        (u*c*a)^n2,(u*c*a)^k2*(c^-1*a*u^-1*c^-1*u^-1*t*a)^l2>;
end function;

function B23(n1,k1,l1, n2,k2,l2, n3,k3,l3)
    return Group<g1,g2,g3,g4,g5|
        g3^3,(g3*g2)^2,(g1,g2),(g4,g5),
        g5*g2^-1*g3^-1*g5^-1*g1^-1*g2^-1*g3^-1*g1,
        g4^-1*g5*g3*g2*g5^-1*g2*g4*g3,

        g2^n1,g2^k1*g1^l1,
        g4^n2,g4^k2*g5^l2,
        (g4*g3*g2)^n3,(g4*g3*g2)^k3*(g2^-1*g5*g3*g2)^l3>;
end function;

function B31(n1,k1,l1, n2,k2,l2, n3,k3,l3)
    return Group<g1,g2,g3,g4,g5|(g1,g3),(g2)^3,(g2*g1^-1)^2,(g5,g4),
        g4*g1^-1*g3^-1*g2*g3*g4^-1*g2*g4*g3^-1*g1^-1*g2*g3*g4^-1*g2,
        g5*g3^-1*g2*g3*g4^-1*g2*g1^-1*g5^-1*g2^-1*g4*g3^-1*g2^-1*g3*g1,
        g2*g3*g4^-1*g2*g1^-1*g4*g3^-1*g2*g3*g4^-1*g1*g2^-1*g4*g3^-1,

        g1^n1,g1^k1*g3^l1,
        g4^n2,g4^k2*g5^l2,
        (g1*g5)^n3,(g1*g5)^k3*(g3^-1*g2*g3*g4^-1*g2*g5)^l3>;
end function;

function B39(n1,k1,l1, n2,k2,l2, n3,k3,l3, n4,k4,l4)
    return Group<g1,g2,g3,g4,g5,g6,g7|
        g3^3,(g4,g6),(g3*g5)^2,(g2,g1),(g1^-1*g3^-1)^2,(g3^-1,g7^-1),
        (g5^-1*g1)^3,g5^-1*g1*g6^-1*g4^-1*g5*g4*g1^-1*g6,
        g4^-1*g5*g4*g2^-1*g7*g5^-1*g7^-1*g2,(g7*g5^-1*g7^-1*g1)^3,
        g6*g1^-1*g5*g6^-1*g4^-1*g5*g4*g1^-1*g4^-1*g5*g4*g1^-1,

        g1^n1, g1^k1*g2^l1,
        g4^n2, g4^k2*g6^l2,
        (g5^-1*g6)^n3, (g5^-1*g6)^k3*(g4*g1^-1*g6)^l3,
        g5^n4, g5^k4*(g4*g2^-1*g7)^l4>;
end function;

function B47(n1,k1,l1,  n2,k2,l2, n3,k3,l3, n4,k4,l4, n5,k5,l5)
    return Group<g1,g2,g3,g4,g5,g6,g7|
        g1^3,(g3,g2),(g2^-1*g1)^2,(g5,g7),g2^-1*g1*g6*g1^-1*g2*g6^-1,
        g6*g2^-1*g4^-1*g5*g3^-1*g6^-1*g4*g2*g3*g5^-1,
        g7^-1*g2^-1*g5^-1*g4*g1*g4^-1*g2*g7*g4*g1^-1*g4^-1*g5,
        g3*g5^-1*g4*g1*g4^-1*g2*g5*g3^-1*g2^-1*g4^-1*g1^-1*g4,
        g5^-1*g4*g1*g4^-1*g7^-1*g2^-1*g4*g1^-1*g4^-1*g5*g3^-1*g2*g3*g7,

        g2^n1,g2^k1*g3^l1,
        g5^n2,g5^k2*g7^l2,
        (g2*g7)^n3, (g2*g7)^k3*(g4*g1^-1*g4^-1*g5)^l3,
        (g6*g2^-1*g4^-1)^n4, (g6*g2^-1*g4^-1)^k4*(g5*g3^-1*g2^-1*g4^-1)^l4,
        (g6^-1*g1^-1*g4)^n5, (g6^-1*g1^-1*g4)^k5*(g3*g5^-1*g4*g1)^l5>;
end function;

function B71(n1,k1,l1,  n2,k2,l2, n3,k3,l3, n4,k4,l4, n5,k5,l5, n6,k6,l6, n7,k7,l7)
    return Group<g1,g2,g3,g4,g5,g6,g7,g8,g9|
        g8^3,(g8^-1,g4),(g8*g7^-1)^2,g1^-1*g3*g7*g3^-1*g1*g7^-1,
        g6*g3*g6^-1*g7*g9^-1*g3^-1*g9*g7^-1,
        g7^-1*g6*g3*g6^-1*g5^-1*g2*g7*g5*g6*g3^-1*g6^-1*g2^-1,
        g8*g7^-1*g1*g5*g6*g3^-1*g1*g5*g7*g8^-1*g5^-1*g1^-1*g3*g6^-1*g5^-1*g1^-1,
        g4^-1*g7^-1*g5^-1*g2*g1^-1*g3*g7*g9*g4*g1*g7^-1*g2^-1*g5*g7*g9^-1*g3^-1,
        (g5*g8*g7^-1*g5^-1*g1^-1*g7*g9*g6*g1*g5*g8*g7^-1*
         g5^-1*g1^-1*g3*g6^-1*g9^-1*g7^-1*g3^-1*g1),
        (g2*g6*g1*g5*g7*g8^-1*g5^-1*g1^-1*g3*g6^-1*g7*g8^-1*g5^-1*
         g2^-1*g5*g7*g8^-1*g5^-1*g1^-1*g7*g8^-1*g1*g5*g6*g3^-1*g6^-1),

        g7^n1,
        g7^k1*(g1^-1*g3)^l1,
        
        g2^n2,
        g2^k2*(g6*g1*g5*g7*g8^-1*g5^-1*g1^-1*g3*g6^-1*g7*g8^-1*g5^-1)^l2,
        
        g3^n3,
        g3^k3*(g6^-1*g7*g9^-1)^l3,
        
        (g7*g2)^n4,
        (g7*g2)^k4*(g6*g3*g6^-1*g5^-1*g7^-1)^l4,
        
        (g7*g9*g6)^n5,
        (g7*g9*g6)^k5*(g3^-1*g1*g5*g8*g7^-1*g5^-1*g1^-1)^l5,
        
        (g3*g9*g4)^n6,
        (g3*g9*g4)^k6*(g4^-1*g7^-1*g5^-1*g2*g7*g1^-1)^l6,

        (g4*g1*g7^-1*g2^-1*g5*g7*g9^-1*g3^-1*g8^-1*g4^-1)^n7,
        ((g4*g1*g7^-1*g2^-1*g5*g7*g9^-1*g3^-1*g8^-1*g4^-1)^k7 *
         (g6*g3^-1*g1*g5*g8*g7^-1*g5^-1*g1^-1*g6^-1*g9^-1*g8^-1*g4^-1)^l7)>;
end function;
