// The entire file can be run from the shell with
//     magma LinkComplementHelpers.m LinkComplement19.m
// or from within magma with
//     load "LinkComplementHelpers.m";
//     load "LinkComplement19.m";
// 

Bianchi19<a,b,t,u> := Group<a,b,t,u|
    a^2,(t*a)^3,b^3,(b*t^-1)^3,(a*b)^2,
    (a*t^-1*u*b*u^-1)^2,(t,u)>;
Bianchi19P := [[ t, u ]];

print "";
print "<(1+sqrt(-19))/2>";

VerifyLink2(Bianchi19, Bianchi19P, [[ 0, 1]], 60);
