from checkMatricesAndPeripheralsHelpers import *

Q = QuadraticField(-2)
psi = Q.gen()
w = psi

a = matrix(Q,[[ 0,-1],[ 1, 0]])
t = matrix(Q,[[ 1, 1],[ 0, 1]])
u = matrix(Q,[[ 1, w],[ 0, 1]])

P = [[ t, u ]]

# Check that we didn't do any mistakes typing in the matrices or
# peripheral elements by checking against the relations and checking
# that the given matrices for P are parabolic.
ensurePslMatricesAreIdentity([a**2,(t*a)**3,(a*u**-1*a*u)**2,Com(t,u)])
ensurePslMatricesAreParabolic(P)
