#!/bin/bash

# This is a shell script generating each principal congruence manifold
# of class number 1 and level <x> with |x| < 6.

# It assumes that sage is in your path.

sage -python generatePrincipalCongruenceManifold.py 1 2 0
sage -python generatePrincipalCongruenceManifold.py 1 2 1
sage -python generatePrincipalCongruenceManifold.py 1 2 2
sage -python generatePrincipalCongruenceManifold.py 1 3 0
sage -python generatePrincipalCongruenceManifold.py 1 3 1
sage -python generatePrincipalCongruenceManifold.py 1 3 2
sage -python generatePrincipalCongruenceManifold.py 1 3 3
sage -python generatePrincipalCongruenceManifold.py 1 4 0
sage -python generatePrincipalCongruenceManifold.py 1 4 1
sage -python generatePrincipalCongruenceManifold.py 1 4 2
sage -python generatePrincipalCongruenceManifold.py 1 4 3
sage -python generatePrincipalCongruenceManifold.py 1 4 4
sage -python generatePrincipalCongruenceManifold.py 1 5 0
sage -python generatePrincipalCongruenceManifold.py 1 5 1
sage -python generatePrincipalCongruenceManifold.py 1 5 2
sage -python generatePrincipalCongruenceManifold.py 1 5 3

sage -python generatePrincipalCongruenceManifold.py 2 0 2
sage -python generatePrincipalCongruenceManifold.py 2 0 3
sage -python generatePrincipalCongruenceManifold.py 2 0 4
sage -python generatePrincipalCongruenceManifold.py 2 1 1
sage -python generatePrincipalCongruenceManifold.py 2 1 2
sage -python generatePrincipalCongruenceManifold.py 2 1 3
sage -python generatePrincipalCongruenceManifold.py 2 1 4
sage -python generatePrincipalCongruenceManifold.py 2 2 0
sage -python generatePrincipalCongruenceManifold.py 2 2 1
sage -python generatePrincipalCongruenceManifold.py 2 2 2
sage -python generatePrincipalCongruenceManifold.py 2 2 3
sage -python generatePrincipalCongruenceManifold.py 2 3 0
sage -python generatePrincipalCongruenceManifold.py 2 3 1
sage -python generatePrincipalCongruenceManifold.py 2 3 2
sage -python generatePrincipalCongruenceManifold.py 2 3 3
sage -python generatePrincipalCongruenceManifold.py 2 4 0
sage -python generatePrincipalCongruenceManifold.py 2 4 1
sage -python generatePrincipalCongruenceManifold.py 2 4 2
sage -python generatePrincipalCongruenceManifold.py 2 4 3
sage -python generatePrincipalCongruenceManifold.py 2 5 0
sage -python generatePrincipalCongruenceManifold.py 2 5 1
sage -python generatePrincipalCongruenceManifold.py 2 5 2

sage -python generatePrincipalCongruenceManifold.py 3 2 0
sage -python generatePrincipalCongruenceManifold.py 3 5/2 1/2
sage -python generatePrincipalCongruenceManifold.py 3 3 0
sage -python generatePrincipalCongruenceManifold.py 3 3 1
sage -python generatePrincipalCongruenceManifold.py 3 7/2 1/2
sage -python generatePrincipalCongruenceManifold.py 3 4 0
sage -python generatePrincipalCongruenceManifold.py 3 4 1
sage -python generatePrincipalCongruenceManifold.py 3 9/2 1/2
sage -python generatePrincipalCongruenceManifold.py 3 9/2 3/2
sage -python generatePrincipalCongruenceManifold.py 3 5 0
sage -python generatePrincipalCongruenceManifold.py 3 5 1
sage -python generatePrincipalCongruenceManifold.py 3 11/2 1/2

sage -python generatePrincipalCongruenceManifold.py 7 0 1
sage -python generatePrincipalCongruenceManifold.py 7 0 2
sage -python generatePrincipalCongruenceManifold.py 7 1/2 1/2
sage -python generatePrincipalCongruenceManifold.py 7 1/2 3/2
sage -python generatePrincipalCongruenceManifold.py 7 1 1
sage -python generatePrincipalCongruenceManifold.py 7 1 2
sage -python generatePrincipalCongruenceManifold.py 7 3/2 1/2
sage -python generatePrincipalCongruenceManifold.py 7 3/2 3/2
sage -python generatePrincipalCongruenceManifold.py 7 2 0
sage -python generatePrincipalCongruenceManifold.py 7 2 1
sage -python generatePrincipalCongruenceManifold.py 7 2 2
sage -python generatePrincipalCongruenceManifold.py 7 5/2 1/2
sage -python generatePrincipalCongruenceManifold.py 7 5/2 3/2
sage -python generatePrincipalCongruenceManifold.py 7 3 0
sage -python generatePrincipalCongruenceManifold.py 7 3 1
sage -python generatePrincipalCongruenceManifold.py 7 7/2 1/2
sage -python generatePrincipalCongruenceManifold.py 7 7/2 3/2
sage -python generatePrincipalCongruenceManifold.py 7 4 0
sage -python generatePrincipalCongruenceManifold.py 7 4 1
sage -python generatePrincipalCongruenceManifold.py 7 9/2 1/2
sage -python generatePrincipalCongruenceManifold.py 7 5 0
sage -python generatePrincipalCongruenceManifold.py 7 5 1
sage -python generatePrincipalCongruenceManifold.py 7 11/2 1/2

sage -python generatePrincipalCongruenceManifold.py 11 0 1
sage -python generatePrincipalCongruenceManifold.py 11 1/2 1/2
sage -python generatePrincipalCongruenceManifold.py 11 1/2 3/2
sage -python generatePrincipalCongruenceManifold.py 11 1 1
sage -python generatePrincipalCongruenceManifold.py 11 3/2 1/2
sage -python generatePrincipalCongruenceManifold.py 11 3/2 3/2
sage -python generatePrincipalCongruenceManifold.py 11 2 0
sage -python generatePrincipalCongruenceManifold.py 11 2 1
sage -python generatePrincipalCongruenceManifold.py 11 5/2 1/2
sage -python generatePrincipalCongruenceManifold.py 11 5/2 3/2
sage -python generatePrincipalCongruenceManifold.py 11 3 0
sage -python generatePrincipalCongruenceManifold.py 11 3 1
sage -python generatePrincipalCongruenceManifold.py 11 7/2 1/2
sage -python generatePrincipalCongruenceManifold.py 11 4 0
sage -python generatePrincipalCongruenceManifold.py 11 4 1
sage -python generatePrincipalCongruenceManifold.py 11 9/2 1/2
sage -python generatePrincipalCongruenceManifold.py 11 5 0
sage -python generatePrincipalCongruenceManifold.py 11 11/2 1/2

sage -python generatePrincipalCongruenceManifold.py 19 0 1
sage -python generatePrincipalCongruenceManifold.py 19 1/2 1/2
sage -python generatePrincipalCongruenceManifold.py 19 1 1
sage -python generatePrincipalCongruenceManifold.py 19 3/2 1/2
sage -python generatePrincipalCongruenceManifold.py 19 2 0
sage -python generatePrincipalCongruenceManifold.py 19 2 1
sage -python generatePrincipalCongruenceManifold.py 19 5/2 1/2
sage -python generatePrincipalCongruenceManifold.py 19 3 0
sage -python generatePrincipalCongruenceManifold.py 19 3 1
sage -python generatePrincipalCongruenceManifold.py 19 7/2 1/2
sage -python generatePrincipalCongruenceManifold.py 19 4 0
sage -python generatePrincipalCongruenceManifold.py 19 4 1
sage -python generatePrincipalCongruenceManifold.py 19 9/2 1/2
sage -python generatePrincipalCongruenceManifold.py 19 5 0
sage -python generatePrincipalCongruenceManifold.py 19 11/2 1/2

