// The entire file can be run from the shell with
//     magma LinkComplementHelpers.m LinkComplement5.m
// or from within magma with
//     load "LinkComplementHelpers.m";
//     load "LinkComplement5.m";
// 

Bianchi5<a,b,c,t,u> := Group<a,b,c,t,u |
    (t,u), a^2, b^2, (t*a)^3, (a*b)^2,
    (a*u*b*u^-1)^2, a*c*a*t*c^-1*t^-1,
    u*b*u^-1*c*b*t*c^-1*t^-1>;

Bianchi5P := [[t, u], [t*b, t*u^-1*c*t^-1]];

print "";
print "<3, 1+sqrt(-5)>";

VerifyLink(
    Bianchi5, Bianchi5P,
    [[3,1,1], [3,1,1]], 12,
    Expand([Id(Bianchi5), a, b, a*b],
           [ [ [ 0, 1], [ 0, 1], [ 0, 1], [ 1, 0] ],
             [ [ 0, 1], [ 0, 1], [ 0, 1], [-1, 1] ] ]));

        
