from checkMatricesAndPeripheralsHelpers import *

Q = QuadraticField(-1)
psi = Q.gen()
w = psi

a = matrix(Q,[[ 0,-1],[ 1, 0]])
t = matrix(Q,[[ 1, 1],[ 0, 1]])
u = matrix(Q,[[ 1, w],[ 0, 1]])
l = matrix(Q,[[-psi, 0], [0, psi]])

P = [[ t, u ]]

# Check that we didn't do any mistakes typing in the matrices or
# peripheral elements by checking against the relations and checking
# that the given matrices for P are parabolic.
ensurePslMatricesAreIdentity([
        a**2,l**2,(t*l)**2,(u*l)**2,(a*l)**2,
        (t*a)**3,(u*a*l)**3,Com(t,u)])
ensurePslMatricesAreParabolic(P)
