from checkMatricesAndPeripheralsHelpers import *

Q = QuadraticField(-19)
psi = Q.gen()
w = (1+psi)/2

a = matrix(Q,[[ 0,-1],[ 1, 0]])
t = matrix(Q,[[ 1, 1],[ 0, 1]])
u = matrix(Q,[[ 1, w],[ 0, 1]])
b = matrix(Q,[[1-w, 2], [2, w]])

P = [[ t, u ]]

# Check that we didn't do any mistakes typing in the matrices or
# peripheral elements by checking against the relations and checking
# that the given matrices for P are parabolic.
ensurePslMatricesAreIdentity([
        a**2,(t*a)**3,b**3,(b*t**-1)**3,(a*b)**2,
        (a*t**-1*u*b*u**-1)**2,Com(t,u)])
ensurePslMatricesAreParabolic(P)
